'==========================================================================
'
' VBScript Source File
'
' NAME: cleanup.vbs
'
' AUTHOR: Jeremy Bauer , IBM Corporation
' Updated for iSeries Navigator only:  Linda Hirsch, October 2003
'
' COMMENT: This script needs to be run with the Windows cscript command.
'
'==========================================================================

'--------------------------------------------------------------------------
' SETUP Section

' System names.  The script currently only supports two systems.  If you
' only have one system uncomment the line System2 = "".  Change the system
' names to match the name of your iSeries boxes.
System1 = "tecconf1"
System2 = "tecconf2"  
'System2 = ""

'Leave these empty if your pc userId matches the iSeries userID and the
'password is based on this userID  (ex. uid CA01, pwd CA01PWD)  otherwise,
'you'll need to copy this script to the local PC and modify it for each
'user.
UserID = ""
Password = ""

'Password Suffix this script is written such that user ID's must be
'in the form PREFIXxxSUFFIX where: 
'  PREFIX is some character string, typically CA
'  xx: is some number, ex. 01, 02, 03,... 30
'  SUFFIX is some character string.
'
'The PREFIX is taken from the first part of the Windows UserID
'The xx is taken to be the last two digits of the Windows UserID
'The suffix is defined in the next line.  The default is "pwd".  If none, 
'uncomment the second line
PasswordSuffix = "pwd"
'PasswordSuffix = ""


'Location of files to copy down to the PC
'You must setup a netserver share so these files may be accessed.
'For example, for the default (below), you must have the share caesetup
'created on tecconf1.  Also, make sure everyone can access the share. The
'files in CAESetup.zip must be unzipped into the share (calab).  The
'PCFiles directory will get created when this happens.
FileShareLocation = "\\tecconf1\caesetup\PCFiles"


'Location of the root directory to copy files.  Most labs depend on C:\, but
'if necessary this can be changed
RootDrive = "C:\"

'--------------------------------------------------------------------------

WScript.Echo "iSeries Navigator Lab Cleanup Script"

'Continue the script even if there are errors
On Error Resume Next

'Create a shell object to execute commands
Set WshShell = WScript.CreateObject("WScript.Shell")

'Create a file system object to work with files
Set fso = WScript.CreateObject("Scripting.FileSystemObject")

'Create a network object to access network resources
Set WshNetwork = WScript.CreateObject("WScript.Network")

If Len(UserID) = 0 Then
  UserID = WshNetwork.UserName
End If
UserNumber = Right(UserID, 2)
UserPrefix = Left(UserID, Len(UserID) - 2)
If Len(Password) = 0 Then
  Password = LCase(UserPrefix) & UserNumber & PasswordSuffix
End If
WScript.Echo "Working on user: " & UserID
WScript.Echo "User Number: " & UserNumber
WScript.Echo "Password: " & Password

'Get the install directory from the registry
CAEInstallDir = WshShell.RegRead("HKLM\SOFTWARE\IBM\Client Access\CurrentVersion\InstallPath")
' The registry should always have the full path, but just in case...
If IsNull(CAEInstallDir) Then
  WScript.Echo "Warning!!! - CAE Install directory not found, using default"
	CAEInstallDir = RootDrive & "Program Files\IBM\Client Access"
End If
' WScript.Echo "iSeries Access Install Directory: " & CAEInstallDir

strDesktop = WshShell.SpecialFolders("Desktop")
WScript.Echo "Desktop location: " & strDesktop
strAllUsersDesktop = WshShell.SpecialFolders("AllUsersDesktop")
' WScript.Echo "All Users Desktop location: " & strAllUsersDesktop

' Call subroutines for all the various cleanup steps
Step8
CreateConnections
Step11
Step13
Step15M
Step22


Sub Step1
  WScript.Echo "Step 1: Run this script..."
End Sub
	
Sub Step2
  On Error Resume Next
	WScript.Echo "Step 2: Cleaning up miscellaneous files on the Desktop"
  WScript.Echo "Deleting: " & strDesktop & "\" & "*.AFP"
	fso.DeleteFile strDesktop & "\" & "*.AFP", True  'Delete AFP files
  WScript.Echo "Deleting: " & strDesktop & "\" & "*.DTT"
	fso.DeleteFile strDesktop & "\" & "*.DTT", True  'Delete Data Transfer DTT files
  WScript.Echo "Deleting: " & strDesktop & "\" & "*.DTF"
	fso.DeleteFile strDesktop & "\" & "*.DTF", True  'Delete Data Transfer DTF files
  WScript.Echo "Deleting: " & strDesktop & "\" & "*.TFR"
	fso.DeleteFile strDesktop & "\" & "*.TFR", True  'Delete Data Transfer TFR files
  WScript.Echo "Deleting: " & strDesktop & "\" & "*.TTO"
	fso.DeleteFile strDesktop & "\" & "*.TTO", True  'Delete Data Transfer TTO files
  WScript.Echo "Deleting: " & strDesktop & "\" & "*.AS4"
	fso.DeleteFile strDesktop & "\" & "*.AS4", True  'Delete AS/400 shortcuts
  WScript.Echo "Deleting: " & strDesktop & "\" & "*.WS"
	fso.DeleteFile strDesktop & "\" & "*.WS", True	 'Delete PC5250 workstation profiles
	WScript.Echo "Deleting OpNav shortcuts on desktop"
  DeleteDesktopShortcuts(strDesktop)  'Delete OpNav and 5250 Desktop shortcuts created for the current user
	WScript.Echo "Deleting OpNav shortcuts on desktop for All Users"
  DeleteDesktopShortcuts(strAllUsersDesktop) 'Delete OpNav and 5250 Desktop shortcuts created for all users	
	WScript.Echo "Step 2: Done"
End Sub
  
Sub Step3
  On Error Resume Next
	WScript.Echo "Step 3: Copying new files to the PC, including Emulation Sessions"
  WScript.Echo "Copying files: " &  FileShareLocation & "\*.*" & " to: " & RootDrive
  fso.CopyFile FileShareLocation & "\*.*",  RootDrive  'Copy some files to the rootdrive
  WScript.Echo "Removing files: " & RootDrive & "*.WS"
	fso.DeleteFile RootDrive & "*.WS", True
  WScript.Echo "Copying files: " &  FileShareLocation & "\*.WS" & " to: " & strDesktop
	fso.CopyFile FileShareLocation & "\*.WS", strDesktop, true	
	WScript.Echo "Step 3: Done"
End Sub

Sub Step4
  On Error Resume Next
	'Run through the list of network printers.  Delete those that are configured
	'for system1 or system2 (defined above)
	WScript.Echo "Step 4: Removing network printers"
	Set oPrinters = WshNetwork.EnumPrinterConnections
  For i = 0 to oPrinters.Count - 1 Step 2
    UNCPrinterName = oPrinters.Item(i+1)
    If InStr(UCase(UNCPrinterName),UCase(System1)) Or (Len(System2) > 0 And InStr(UCase(UNCPrinterName), UCase(System2))) Then
      WScript.Echo "Removing printer: " & UNCPrinterName
	    WshNetwork.RemovePrinterConnection UNCPrinterName, True, True
    End If
  Next
  WScript.Echo "Step 4: Done"
End Sub

Sub Step5
  On Error Resume Next
  'Run through the list of network drives.  Delete those that are configured
	'for system1 or system2 (defined above)
	WScript.Echo "Step 5: Removing network drives"
	Set oDrives = WshNetwork.EnumNetworkDrives
	For i = 0 to oDrives.Count - 1 Step 2
    LocalDriveName = oDrives.Item(i)
    UNCDriveName = oDrives.Item(i+1)
    If InStr(UCase(UNCDriveName),UCase(System1)) Or (Len(System2) > 0 And InStr(UCase(UNCDriveName), UCase(System2))) Then
     	If Not(IsNull(LocalDriveName)) Then
        WScript.Echo "Removing drive: " & LocalDriveName
        WshNetwork.RemoveNetworkDrive LocalDriveName, True, True
			End If			
		End If
	Next
  WScript.Echo "Step5: Done"
End Sub

Sub Step6
	'Remove customer.* files from C:\ 
  On Error Resume Next
	WScript.Echo "Step 6: Removing customer.* files from " & RootDrive
	Set oExec = WshShell.Exec("cmd /c del " & RootDrive & "customer.*")
	WriteStdOut(oExec)
	WScript.Echo "Del command return code: " & oExec.Status
	WScript.Echo "Step 6: Done"
End Sub	
  
Sub Step7
	'Remove files like RunSQL from the system
  On Error Resume Next
	WScript.Echo "Step 7: Removing RunSQL files"
    Set fldr = fso.GetFolder(RootDrive)
    DeleteAllFilesNamed fldr, fldr.Name, "RUNSQL?.SQL"	
	WScript.Echo "Step 7: Done"
End Sub

Sub Step8
	'Clean up connections
  On Error Resume Next
	WScript.Echo "Step 8: Running ClearSysReg to clean up connections & settings"
	Set oExec = WshShell.Exec("c:\clearsysreg.exe /b")
	WriteStdOut(oExec)
'	WScript.Echo "Step 8: Done"
End Sub

Sub CreateConnections
	'This step creates new connections to the system after clearsysreg removed the other ones.
  'On Error Resume Next
  WScript.Echo "Intermediate step: Creating new connections to systems."
  WScript.Echo "Enter " & UserID & " as the default user id on the signon panels"
  Set as400 = WScript.CreateObject("cwbx.AS400System")
  as400.Define System1
  as400.UserID = UserID
  as400.Password = Password
  as400.Signon
  if Len(System2) > 0 Then
    Set as4002 = WScript.CreateObject("cwbx.AS400System")
    as4002.Define System2
    as4002.UserID = UserID
    as4002.PersistenceMode = 0
    as4002.Password = Password
    as4002.Signon
  End If
  WScript.Echo "Intermediate step: Done" 
End Sub

Sub Step9
  'This step ensures that print shares are cleaned up
  On Error Resume Next
	WScript.Echo "Step 9: MANUAL - Stop sharing PRTCAxx printer through iSeries Navigator"
	MsgBox "Use iSeries Navigator to stop sharing printers named PRTCA" & userNumber & ".", vbExclamation, "Manual Cleanup - Printer Shares"
	WScript.Echo "Step 9: Done"
End Sub

Sub Step10
  On Error Resume Next
	WScript.Echo "Step 10: Making sure iSeries Access Welcome Wizard Starts"
	WshShell.RegWrite "HKLM\SOFTWARE\IBM\Client Access\CurrentVersion\Selectively_Installable_Components\Client Access Express Base Support\WelcomeWizard\Display", 1, "REG_DWORD"
	WScript.Echo "Step 10: Done"
End Sub

Sub Step11
  On Error Resume Next
	WScript.Echo "Step 11: Making sure iSeries Navigator online help Starts"
	WshShell.RegDelete "HKCU\Software\IBM\Client Access Express\CurrentVersion\AS400 Operations Navigator\Splash Screen\Enable"
'	WScript.Echo "Step 11: Done"
End Sub

Sub Step12
  On Error Resume Next
	WScript.Echo "Step 12: Checking/Adding Data Transfer Excel Add-in"
	regval = WshShell.RegRead("HKCU\Software\Microsoft\Office\9.0\Excel\Options\Open")
	If IsNull(regval) or Len(regval) = 0 Then
		addinKey = "/R " & CStr(Chr(34)) & CAEInstallDir & "\shared\cwbtfxla.xll" & CStr(Chr(34))
     WScript.Echo "Writing key: " & addinKey
		WshShell.RegWrite "HKCU\Software\Microsoft\Office\9.0\Excel\Options\Open", addinKey, "REG_SZ"
	End if
	regval = WshShell.RegRead("HKCU\Software\Microsoft\Office\10.0\Excel\Options\Open")
	If IsNull(regval) Then
		addinKey = "/R " & CStr(Chr(34)) & CAEInstallDir & "\shared\cwbtfxla.xll" & CStr(Chr(34))
		WshShell.RegWrite "HKCU\Software\Microsoft\Office\10.0\Excel\Options\Open", addinKey, "REG_SZ"
	End if
	WScript.Echo "Step 12: Done"
End Sub

Sub Step13
  On Error Resume Next
	WScript.Echo "Step 13: Running cleanup program on systems"
	hostCommand = "CALL PGM(CASETUP/LABCLNBSC) PARM(" & UserNumber & " '" & UserPrefix & "')"
	runCommand = "RMTCMD " & hostCommand & " //" & System1
'	WScript.Echo "Running command: " & runCommand
	Set oExec = WshShell.Exec(runCommand)
	WriteStdOut(oExec)
  If Len(System2) > 0 Then
	  runCommand = "RMTCMD " & hostCommand & " //" & System2
' 	WScript.Echo "Running command: " & runCommand
	  Set oExec = WshShell.Exec(runCommand)
	  WriteStdOut(oExec)
  End If
'	WScript.Echo "Step 13: Done"
End Sub

Function Step14
  On Error Resume Next
	WScript.Echo "Step 14: Skipping logoff - doing advanced cleanup"
	retc = MsgBox ("Run advanced cleanup steps?", vbYesNo, "Advanced Cleanup?")
	If retc = vbNo Then
		WScript.Echo "Step 14: Exiting cleanup"
		WScript.Echo "Step 14: Done"
  Else
	  WScript.Echo "Step 14: Continuing cleanup"
	  WScript.Echo "Step 14: Done"
  End If
  Step14 = retc
End Function
	
Sub Step15
  On Error Resume Next
	WScript.Echo "Step 15: Cleaning up Database Display Libraries"
	Set oExec = WshShell.Exec(RootDrive & "odbccln /L " & System1 & " " & UserId & " " & Password)
	WriteStdOut(oExec)
	WScript.Echo "odbccln command return code: " & oExec.Status
  If Len(System2) > 0 Then
	  Set oExec = WshShell.Exec(RootDrive & "odbccln /L " & System2 & " " & UserId & " " & Password)
	  WriteStdOut(oExec)
	  WScript.Echo "odbccln command return code: " & oExec.Status
  End If
	WScript.Echo "Step 15: Done"
End Sub

Sub Step15M
  'This step ensures that MC is cleaned up
  On Error Resume Next
	WScript.Echo "Step 15M: MANUAL - Clean up MC command and user definitions"
	MsgBox "In iSeries Navigator, go to Management Central:  1) Remove all command and user definitions, 2) Delete all task activites, 3) END and DELETE CPU" & userNumber & " system monitor if it exists.", vbExclamation, "Manual Cleanup - Management Central"
'	WScript.Echo "Step 15M: Done"
End Sub

Sub Step16
  On Error Resume Next
	WScript.Echo "Step 16: Checking SSL Connections"
	' Nothing to do here. CLRSYSREG should have deleted connections, new ones should not use SSL
	WScript.Echo "Step 16: Done"
End Sub

Sub Step17
  On Error Resume Next
	WScript.Echo "Step 17: Checking Data Transfer SSL Connections"
	' Nothing to do here. New connections should default to not use SSL
	WScript.Echo "Step 17: Done"
End Sub

Sub Step18
  On Error Resume Next
	WScript.Echo "Step 18: Cleaning up IKEYMAN Database"
	' Nothing to do here.  The lab step will overwrite the key database item
	WScript.Echo "Step 18: Done"
End Sub

Sub Step19
  On Error Resume Next
	WScript.Echo "Step 19: Cleaning up policy settings"
	regkey = "HKCU\Software\Policies\IBM\Client Access Express\Restrictions\Emulator\Prevent usage of emulator"
	WshShell.RegDelete regkey
	WScript.Echo "Step 19: Done"
End Sub


'--------------------------------------------------------------------------
' 
' Sub Step20
'  On Error Resume Next
'	WScript.Echo "Step 20: Resetting Incoming Remote command service"
'	Set oExec = WshShell.Exec("sc stop cwbrxd")
'	WriteStdOut(oExec)
'	WScript.Echo "SC stop command return code: " & oExec.Status
'	Set oExec = WshShell.Exec("sc config cwbrxd start= demand")
'	WriteStdOut(oExec)
'	WScript.Echo "SC config command return code: " & oExec.Status
'	WScript.Echo "Step 20: Done Resetting Incoming Remote command service"
' End Sub

Sub Step21
  On Error Resume Next
	WScript.Echo "Step 21: Cleaning up ODBC DSN's with odbccln"
	Set oExec = WshShell.Exec(RootDrive & "odbccln /D")
	WriteStdOut(oExec)
	WScript.Echo "odbccln command return code: " & oExec.Status
	WScript.Echo "Step 21: Done"
End Sub

Sub Step22
  On Error Resume Next
	WScript.Echo "Step 22: Reset App Admin to defaults"
	MsgBox "MANUAL - For each iSeries, go into App. Admin.  Remove all Customized Access settings and set All Object and Default Access on (checked) for each function in App. Admin.", vbOK, "Manual Cleanup - Reset App Admin"
	WScript.Echo "Lab Cleanup Complete"
End Sub

Sub Logoff
  On Error Resume Next
	WScript.Echo "Step Logoff: Log off the current user"
	MsgBox "Cleanup is complete.  Log off the workstation to make it ready for the next user.", vbOK, "Log Off"
	WScript.Echo "Step Logoff: Done"
End Sub

Sub WriteStdOut(oExec)
  On Error Resume Next
	Do While Not oExec.StdOut.AtEndOfStream
		WScript.Echo oExec.StdOut.ReadLine
	Loop
End Sub

Sub DeleteAllFilesNamed(fldr, subdir, fileName)
	If Not(IsNull(fldr)) Then
    On Error Resume Next
		fso.DeleteFile subdir & "\" & fileName, true
		For Each fldr2 In fldr.SubFolders
	   		DeleteAllFilesNamed fldr2, subdir & "\" & fldr2.Name, fileName
	  Next 
  End If
End Sub

Sub DeleteDesktopShortcuts(location)
  On Error Resume Next
	Set desktopFolder = fso.GetFolder(location)
	Set lnkFiles = desktopFolder.Files
	For Each lnkFile in lnkFiles
		If Not(IsNull(lnkFile)) and (Len(lnkFile) > 0) and lnkFile.type = "Shortcut" Then
      if (lnkFile.name <> "iSeries Navigator.lnk") Then
         Set oShellLink = WshShell.CreateShortcut(location & "\" & lnkFile.name)
         If Not(IsNull(oShellLink)) And (InStr(oShellLink.TargetPath, "cwbunnav") Or InStr(oShellLink.TargetPath, "pcsws")) Then
           WScript.Echo "Deleting shortcut: " & location & "\" & lnkFile.name
           fso.DeleteFile location & "\" & lnkFile.name
          end if
      End if
    End If
  Next
End Sub
